<?php

namespace \Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetCredentialPolicyDefaultReq StructType
 * @subpackage Structs
 */
class GetCredentialPolicyDefaultReq extends AbstractStructBase
{
    /**
     * The credentialUser
     * Meta information extracted from the WSDL
     * - choice: credentialUser | credentialType | credPolicyName
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $credentialUser;
    /**
     * The credentialType
     * Meta information extracted from the WSDL
     * - choice: credentialUser | credentialType | credPolicyName
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $credentialType;
    /**
     * The credPolicyName
     * Meta information extracted from the WSDL
     * - choice: credentialUser | credentialType | credPolicyName
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $credPolicyName;
    /**
     * The returnedTags
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\RCredentialPolicyDefault
     */
    public $returnedTags;
    /**
     * The sequence
     * Meta information extracted from the WSDL
     * - use: optional
     * @var int
     */
    public $sequence;
    /**
     * Constructor method for GetCredentialPolicyDefaultReq
     * @uses GetCredentialPolicyDefaultReq::setCredentialUser()
     * @uses GetCredentialPolicyDefaultReq::setCredentialType()
     * @uses GetCredentialPolicyDefaultReq::setCredPolicyName()
     * @uses GetCredentialPolicyDefaultReq::setReturnedTags()
     * @uses GetCredentialPolicyDefaultReq::setSequence()
     * @param string $credentialUser
     * @param string $credentialType
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $credPolicyName
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\RCredentialPolicyDefault $returnedTags
     * @param int $sequence
     */
    public function __construct($credentialUser = null, $credentialType = null, \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $credPolicyName = null, \\Losc\CucmBundle\Model\Webservice\StructType\RCredentialPolicyDefault $returnedTags = null, $sequence = null)
    {
        $this
            ->setCredentialUser($credentialUser)
            ->setCredentialType($credentialType)
            ->setCredPolicyName($credPolicyName)
            ->setReturnedTags($returnedTags)
            ->setSequence($sequence);
    }
    /**
     * Get credentialUser value
     * @return string
     */
    public function getCredentialUser()
    {
        return isset($this->credentialUser) ? $this->credentialUser : null;
    }
    /**
     * Set credentialUser value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param string $credentialUser
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\GetCredentialPolicyDefaultReq
     */
    public function setCredentialUser($credentialUser = null)
    {
        if (is_null($credentialUser) || (is_array($credentialUser) && empty($credentialUser))) {
            unset($this->credentialUser);
        } else {
            $this->credentialUser = $credentialUser;
        }
        return $this;
    }
    /**
     * Get credentialType value
     * @return string
     */
    public function getCredentialType()
    {
        return isset($this->credentialType) ? $this->credentialType : null;
    }
    /**
     * Set credentialType value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param string $credentialType
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\GetCredentialPolicyDefaultReq
     */
    public function setCredentialType($credentialType = null)
    {
        if (is_null($credentialType) || (is_array($credentialType) && empty($credentialType))) {
            unset($this->credentialType);
        } else {
            $this->credentialType = $credentialType;
        }
        return $this;
    }
    /**
     * Get credPolicyName value
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public function getCredPolicyName()
    {
        return isset($this->credPolicyName) ? $this->credPolicyName : null;
    }
    /**
     * Set credPolicyName value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $credPolicyName
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\GetCredentialPolicyDefaultReq
     */
    public function setCredPolicyName(\\Losc\CucmBundle\Model\Webservice\StructType\XFkType $credPolicyName = null)
    {
        if (is_null($credPolicyName) || (is_array($credPolicyName) && empty($credPolicyName))) {
            unset($this->credPolicyName);
        } else {
            $this->credPolicyName = $credPolicyName;
        }
        return $this;
    }
    /**
     * Get returnedTags value
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\RCredentialPolicyDefault|null
     */
    public function getReturnedTags()
    {
        return $this->returnedTags;
    }
    /**
     * Set returnedTags value
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\RCredentialPolicyDefault $returnedTags
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\GetCredentialPolicyDefaultReq
     */
    public function setReturnedTags(\\Losc\CucmBundle\Model\Webservice\StructType\RCredentialPolicyDefault $returnedTags = null)
    {
        $this->returnedTags = $returnedTags;
        return $this;
    }
    /**
     * Get sequence value
     * @return int|null
     */
    public function getSequence()
    {
        return $this->sequence;
    }
    /**
     * Set sequence value
     * @param int $sequence
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\GetCredentialPolicyDefaultReq
     */
    public function setSequence($sequence = null)
    {
        $this->sequence = $sequence;
        return $this;
    }
}
